# Interface PooledObjectFactory<T>

Type Parameters:
  `T` - Type of element managed in this factory.

All Known Implementing Classes:
  `PoolableConnectionFactory, PoolableManagedConnectionFactory`

public interface PooledObjectFactory<T>
An interface defining life-cycle methods for instances to be served by an `ObjectPool`.

By contract, when an `ObjectPool` delegates to a `PooledObjectFactory`,

1. `makeObject()` is called whenever a new instance is needed.
2. `activateObject(PooledObject)` is invoked on every instance that has been `passivated` before it is `borrowed` from the pool.
3. `validateObject(PooledObject)` may be invoked on `activated` instances to make sure they can be `borrowed` from the pool. `validateObject(PooledObject)` may also be used to test an instance being `returned` to the pool before it is `passivated`. It will only be invoked on an activated instance.
4. `passivateObject(PooledObject)` is invoked on every instance when it is returned to the pool.
5. `destroyObject(PooledObject)` is invoked on every instance when it is being "dropped" from the pool (whether due to the response from `validateObject(PooledObject)`, or for reasons specific to the pool implementation.) There is no guarantee that the instance being destroyed will be considered active, passive or in a generally consistent state.

`PooledObjectFactory` must be thread-safe. The only promise an `ObjectPool` makes is that the same instance of an object will not be passed to more than one method of a `PoolableObjectFactory` at a time.

While clients of a `KeyedObjectPool` borrow and return instances of the underlying value type `V`, the factory methods act on instances of `PooledObject<V>`. These are the object wrappers that pools use to track and maintain state information about the objects that they manage.

Since:
  2.0
See Also:
  - `ObjectPool`

## Method Summary

Modifier and Type
Method
Description
`void`
`activateObject(PooledObject<T> p)`
Reinitializes an instance to be returned by the pool.
`void`
`destroyObject(PooledObject<T> p)`
Destroys an instance no longer needed by the pool, using the default (NORMAL) DestroyMode.
`default void`
`destroyObject(PooledObject<T> p, DestroyMode destroyMode)`
Destroys an instance no longer needed by the pool, using the provided DestroyMode.
`PooledObject<T>`
`makeObject()`
Creates an instance that can be served by the pool and wrap it in a `PooledObject` to be managed by the pool.
`void`
`passivateObject(PooledObject<T> p)`
Uninitializes an instance to be returned to the idle object pool.
`boolean`
`validateObject(PooledObject<T> p)`
Ensures that the instance is safe to be returned by the pool.

## Method Details

### activateObject

void activateObject(PooledObject<T> p) throws Exception
Reinitializes an instance to be returned by the pool.

Parameters:
  `p` - a `PooledObject` wrapping the instance to be activated
Throws:
  `Exception` - if there is a problem activating `obj`, this exception may be swallowed by the pool.
See Also:
  - `destroyObject(PooledObject)`

### destroyObject

void destroyObject(PooledObject<T> p) throws Exception
Destroys an instance no longer needed by the pool, using the default (NORMAL) DestroyMode.

It is important for implementations of this method to be aware that there is no guarantee about what state `obj` will be in and the implementation should be prepared to handle unexpected errors.

Also, an implementation must take in to consideration that instances lost to the garbage collector may never be destroyed.

Parameters:
  `p` - a `PooledObject` wrapping the instance to be destroyed
Throws:
  `Exception` - should be avoided as it may be swallowed by the pool implementation.
See Also:
  - `validateObject(PooledObject)`
  - `ObjectPool.invalidateObject(T)`

### destroyObject

default void destroyObject(PooledObject<T> p, DestroyMode destroyMode) throws Exception
Destroys an instance no longer needed by the pool, using the provided DestroyMode.

Parameters:
  `p` - a `PooledObject` wrapping the instance to be destroyed
  `destroyMode` - DestroyMode providing context to the factory
Throws:
  `Exception` - should be avoided as it may be swallowed by the pool implementation.
Since:
  2.9.0
See Also:
  - `validateObject(PooledObject)`
  - `ObjectPool.invalidateObject(T)`
  - `destroyObject(PooledObject)`
  - `DestroyMode`

### makeObject

PooledObject<T> makeObject() throws Exception
Creates an instance that can be served by the pool and wrap it in a `PooledObject` to be managed by the pool.

Returns:
  a `PooledObject` wrapping an instance that can be served by the pool, not null.
Throws:
  `Exception` - if there is a problem creating a new instance, this will be propagated to the code requesting an object.

### passivateObject

void passivateObject(PooledObject<T> p) throws Exception
Uninitializes an instance to be returned to the idle object pool.

Parameters:
  `p` - a `PooledObject` wrapping the instance to be passivated
Throws:
  `Exception` - if there is a problem passivating `obj`, this exception may be swallowed by the pool.
See Also:
  - `destroyObject(PooledObject)`

### validateObject

boolean validateObject(PooledObject<T> p)
Ensures that the instance is safe to be returned by the pool.

Parameters:
  `p` - a `PooledObject` wrapping the instance to be validated
Returns:
  `false` if `obj` is not valid and should be dropped from the pool, `true` otherwise.